<?php
if ( ! defined( 'ABSPATH' ) ) {
    die( '-1' );
}
class WPBakeryShortCode_customPostRedo extends WPBakeryShortCode
{

    protected function content($atts, $content = null)
    {
        extract(shortcode_atts(array(
            '' => '',
        ), $atts));
        
        
        $postTypes = explode(",",$atts['redo_post']);
        
        //VC_REDO::debug($atts['redo_post'], true);
            ob_start(); ?>

                <!-- HTML DESIGN HERE -->
                <?php if(!empty($postTypes)) : ?>
                <?php foreach($postTypes as $postType) : ?>
                    <div class="post-type-container <?php echo $postType ?>">
                    <h2><?php echo $postType ?></h2>
                    <?php 
                    $postList = get_posts(array(
                        'post_type' => $postType,
                        'posts_per_page' => -1
                    ));
                    $postFields = explode(",",$atts[$postType.'_post_support']);
                    $customFields = explode(",",$atts[$postType.'_field_support']); ?>
                        <?php if(!empty($postList)) : ?>
                        <?php foreach($postList as $myPost): ?>
                            <div class="post-container <?php echo $postType ?>">
                            <!-- Wyświetlenie wybranych pól posta -->
                            <?php if(!empty($postFields)) : ?>
                            <?php foreach($postFields as $key => $value) : ?>
                                <div class="post-field-container <?php echo $value ?>">
                                    
                                    <?php if($value=="thumbnail") {
                                        echo get_the_post_thumbnail($myPost->ID, 'medium');
                                    }
                                    else { ?>
                                        <?php echo get_post_field("post_".$value, $myPost->ID); ?>
                                    <?php } ?>
                                </div>
                            <?php endforeach; ?>
                            <?php endif; ?>                 
                            <?php if(!empty($customFields)) : ?>
                            <?php foreach($customFields as $key => $value) : ?>
                                <div class="custom-field-container <?php echo $value ?>">
                                    <?php $customField = get_field($value,$myPost->ID);
                                        if(is_array($customField)) {
                                            $size = 'thumbnail';
                                            echo '<img src="' . esc_url( $customField['sizes'][$size] ) . '"/>';
                                        }
                                        else {
                                            echo $customField;
                                        }
                                    ?>
                                </div>
                            
                            <?php endforeach; ?>
                            <?php endif; ?>
                            </div>
                        <?php endforeach; ?>
                        <?php endif; ?>
                        </div>
                <?php endforeach; ?>
                <?php endif; ?>
                <!-- HTML END DESIGN HERE -->
            <?php
            return ob_get_clean();
    }
}

$customPostList = get_option( 'cptui_post_types' );
//VC_REDO::debug($customPostList, true);
$_custom_posts = array();

$_custom_posts_params = array();


if($customPostList){
    foreach($customPostList as $postList){
        $_custom_posts_params[$postList["label"]] = $postList["name"];
        $_custom_posts[$postList["name"]]["type"] = $postList["name"];
        $_custom_posts[$postList["name"]]["label"] = $postList["label"];
        $supportsArray = array_flip($postList["supports"]);
        
        foreach($supportsArray as $key => $value){
            $supportsArray[$key] = $key;
        }
        $_custom_posts[$postList["name"]]["supports"] = $supportsArray;
        
    }
}
//VC_REDO::debug($_custom_posts, true);

$fields = VC_REDO::prepareCustomFields();
$customFieldsList = array();
if($fields){
    foreach($fields as $field){
        $customFieldsList[$field["title"]]["customFields"] = $field["fields"];
    }
}




$paramsArray[] =  array(
    "type" => "checkbox",
    "heading" => __("Choose your Post Type"),
    "param_name" => "redo_post",
    "value" => $_custom_posts_params,
    "description" => __("Choose Post Type which you want to display"),
);


foreach($_custom_posts as $key => $cp){
    $custom_params = $cp["supports"];
    unset($custom_params["custom-fields"]);
    $paramsArray[] = array(
        "type" => "checkbox",
        "heading" => __("Chose additional fields for " . $cp["label"]),
        "param_name" => $key. "_post_support",
        "value" => $custom_params,
        "description" => __("Check fields that you need"),
    );
     
    if($cp["supports"]["custom-fields"]){
    foreach($customFieldsList as $fk => $fv){
        $customList = $fv["customFields"];
        //VC_REDO::debug($customList, true);
        foreach($customList as $ck => $cv) {
            $customList[$ck] = $ck;
        }
        $paramsArray[] = array(
            "type" => "checkbox",
            "heading" => __("Chose custom fields for " . $cp["label"]),
            "param_name" => $key. "_field_support",
            "value" => $customList,
            "description" => __("Check custom fields that you need"),
            );
        }   
    }    
}


vc_map( array(
        "name" 			=> __( 'Custom Post Widget', 'customPostRedo' ),
        "base" 			=> "customPostRedo",
        "category" 		=> __('REDO JSComposer Additional'),
        "description" 	=> __('Display view for Custom Post Type'),
        "icon" => plugin_dir_url( __FILE__ ).'../images/eye-icon.png',
        'params' =>
            $paramsArray
        ,
) );
   
